/**
 * DESCRIPTION OF THE FILE
 *
 * @author Michal Kravčenko
 * @date 13.6.18 -
 */

#include "Connection.h"

Connection* Connection::get_copy(Neuron *n_in, Neuron *n_out){
    Connection *output = new Connection(n_in, n_out, this->con, false);
    return output;
}

Connection::Connection(Neuron *n_in, Neuron *n_out, ConnectionWeight* con, bool del_weight) {
    this->neuron_in = n_in;
    this->neuron_out = n_out;

    this->con = con;
    this->delete_connection = del_weight;
}

Connection::~Connection() {
    if(this->con && this->delete_connection ){
        delete this->con;
        this->con = nullptr;
    }
}

void Connection::adjust_weights(double* values) {
    this->con->adjust_weights(values);
}


Neuron* Connection::get_neuron_in() {
    return this->neuron_in;
}

Neuron* Connection::get_neuron_out() {
    return this->neuron_out;
}

//double Connection::get_weight() {
//    return this->weight;
//}

void Connection::pass_signal() {
#ifdef VERBOSE_NN_EVAL
    printf("  passing signal between neurons %d -> %d, value: %f * %f\n", this->neuron_in, this->neuron_out, this->neuron_in->get_state(), this->con->eval());
#endif
    this->neuron_out->adjust_potential(this->neuron_in->get_state() * this->con->eval());
}

void Connection::set_weights(double *values) {
    this->con->set_weights(values);
}
