/**
 * DESCRIPTION OF THE FILE
 *
 * @author Michal Kravčenko
 * @date 14.6.18 -
 */

#ifndef INC_4NEURO_CONNECTIONWEIGHT_H
#define INC_4NEURO_CONNECTIONWEIGHT_H

#include <functional>
#include <vector>

class ConnectionWeight {
protected:
    /**
     *
     */
    std::vector<double> * weight_array = nullptr;

    /**
     *
     */
    int* param_indices = nullptr;

    /**
     *
     */
    int n_params = 0;

public:

    /**
     *
     */
    ConnectionWeight();

    /**
     *
     * @param param_count
     * @param f
     */
    ConnectionWeight(int param_count, std::vector<double>* w_array);

    /**
     *
     * @param value
     * @param idx
     */
    void SetParamIndex(int value, int idx);

    /**
     *
     * @param param_ptr
     */
    void SetParamIndices(int* param_ptr);

    /**
     *
     */
    virtual ~ConnectionWeight();

    /**
     *
     * @return
     */
    virtual double eval();

    /**
     *
     * @param values
     */

    void set_weights(double *values);

    /**
     *
     * @return vector of weights
     */
    std::vector<double> get_weights();
    /**
     *
     * @param values
     */
    void adjust_weights(double *values);

};


#endif //INC_4NEURO_CONNECTIONWEIGHT_H
