/**
 * DESCRIPTION OF THE FILE
 *
 * @author Michal Kravčenko
 * @date 18.7.18 -
 */

#ifndef INC_4NEURO_NEURALNETWORKSUM_H
#define INC_4NEURO_NEURALNETWORKSUM_H

#include "NeuralNetwork.h"

class NeuralNetworkSum : public NeuralNetwork {
private:
    std::vector<NeuralNetwork*> * summand;
    std::vector<double> * summand_coefficient;

public:
    NeuralNetworkSum();
    virtual ~NeuralNetworkSum();

    void add_network( NeuralNetwork *net, double alpha = 1.0 );

    virtual void eval_single(std::vector<double> &input, std::vector<double> &output, double *custom_weights = nullptr) override;

    virtual size_t get_n_weights();
};


#endif //INC_4NEURO_NEURALNETWORKSUM_H
