
#include "Neuron.h"

//TODO write INIT method to allocate edges_in and edges_out, so
// it doesn't have to be written in every inherited class
Neuron::~Neuron() {
    if(this->activation_function_parameters){
        delete [] this->activation_function_parameters;
        this->activation_function_parameters = nullptr;
    }

    if(this->edges_out){
        for(auto *edge: *this->edges_out){
            delete edge;
        }
        delete this->edges_out;
        this->edges_out = nullptr;
    }

    if(this->edges_in){
        delete this->edges_in;
        this->edges_in = nullptr;
    }
}

void Neuron::set_saturation_in(int value) {
    this->n_saturated_connections_in = value;
}

void Neuron::adjust_saturation_in(int value) {
    this->n_saturated_connections_in += value;
}

bool Neuron::is_saturated_in() {
    if(this->n_saturated_connections_in == this->edges_in->size()){
        return true;
    }

    return false;
}

void Neuron::set_saturation_out(int value) {
    this->n_saturated_connections_out = value;
}

void Neuron::adjust_saturation_out(int value) {
    this->n_saturated_connections_out += value;
}


bool Neuron::is_saturated_out() {
    return this->n_saturated_connections_out == this->edges_out->size();
}


void Neuron::adjust_potential(double input_signal) {
    this->potential += input_signal;
}

double Neuron::get_potential() {
    return this->potential;
}

void Neuron::set_potential(double value) {
    this->potential = value;
}

double Neuron::get_state() {
    return this->state;
}

void Neuron::set_state(double value) {
    this->state = value;
}

int Neuron::activation_function_get_n_parameters(){
    return this->n_activation_function_parameters;
}

void Neuron::activation_function_adjust_parameter(int param_idx, double value) {
    this->activation_function_parameters[param_idx] += value;
}

void Neuron::activation_function_set_parameter(int param_idx, double value) {
    this->activation_function_parameters[param_idx] = value;
}


double Neuron::activation_function_get_parameter(int param_idx) {
    /**
     * TODO
     * Check out of range
     */
    return this->activation_function_parameters[param_idx];
}

void Neuron::add_connection_in(Connection *con) {
    if(!this->edges_in){
        this->edges_in = new std::vector<Connection*>(0);
    }
    this->edges_in->push_back(con);
}

void Neuron::add_connection_out(Connection *con) {
    if(!this->edges_out){
        this->edges_out = new std::vector<Connection*>(0);
    }
    this->edges_out->push_back(con);
}

std::vector<Connection*>* Neuron::get_connections_in() {
    return this->edges_in;
}

std::vector<Connection*>* Neuron::get_connections_out() {
    return this->edges_out;
}

size_t Neuron::get_idx() {
    return this->neural_net_index;
}

void Neuron::set_idx(size_t value) {
    this->neural_net_index = value;
}

Neuron* IDifferentiable::get_derivative() {
    return nullptr;
}


//template<class Archive>
//void Neuron::serialize(Archive & ar, const unsigned int version) {
//    ar << this->potential;
//    ar << this->state;
//}