/**
* DESCRIPTION OF THE CLASS
*
* @author David Vojtek
* @date 2018
*/

#define BOOST_TEST_NO_MAIN

#include <boost/test/unit_test.hpp>
#include "../NetConnection/ConnectionWeightIdentity.h"

/**
 * Boost testing suite for testing ConnectionWeightIdentity.h
 */
BOOST_AUTO_TEST_SUITE(ConnectionWeightIdentity_test)

    /**
     * Test of correct construction of ConnectionWeightIdentity
     */
    BOOST_AUTO_TEST_CASE(ConnectionWeightIdentity_construction_test) {
        std::vector<double> weight_array = {1, 2, 3, 4, 5};
        //Test of none exception when creation new instance of ConnectionWeightIdentity
        BOOST_CHECK_NO_THROW(ConnectionWeightIdentity CWI(&weight_array));
    }

    /**
     * Test of eval method
     */
    BOOST_AUTO_TEST_CASE(ConnectionWeightIdentity_eval_test) {
        std::vector<double> weight_array = {1, 2, 3, 4, 5};
        ConnectionWeightIdentity CWI(&weight_array);
        int para[5] = {3, 1, 2, 3, 4};
        CWI.SetParamIndices(para);

        //Test of correct output of eval method
        BOOST_CHECK_EQUAL(4, CWI.eval());
    }

BOOST_AUTO_TEST_SUITE_END()
