/**
 * DESCRIPTION OF THE CLASS
 *
 * @author David Vojtek
 * @date 2018
 */

#define BOOST_TEST_NO_MAIN

#include <boost/test/unit_test.hpp>
#include "../Neuron/NeuronBinary.h"

/**
 * Boost testing suite for testing NeuronBinary.h
 * doesn't test inherited methods
 */
BOOST_AUTO_TEST_SUITE(neuronBinary_test)

    /**
     * Test of creating new instance of NeuronBinary
     */
    BOOST_AUTO_TEST_CASE(neuronLinear_construction__test) {
        NeuronBinary neuron(1.745);
        //Test of correct value of activation function parameter
        BOOST_CHECK_EQUAL(neuron.activation_function_get_parameter(0), 1.745);
    }

    /**
     * Test of activate method
     */
    BOOST_AUTO_TEST_CASE(neuronLinear_activate__test) {
        NeuronBinary neuron(1.75);
        neuron.activate();
        //Test of correct state neuron
        BOOST_CHECK_EQUAL(0.0, neuron.get_state());
        neuron.set_potential(1.76);
        neuron.activate();
        //Another test of correct state of neuron
        BOOST_CHECK_EQUAL(1.0, neuron.get_state());
    }

BOOST_AUTO_TEST_SUITE_END()